#include "gui_fsm.hpp"
#include "textures.hpp"
#include "sound.hpp"

int main() {
  textures::init();
  sound::init();
  gui::FSM main;
  main.event(gui::Event::STARTED);

  while(main.active()) {
    main.render();

    // ZED: need to sort out how to deal with this in the FSM
    if(main.in_state(gui::State::IDLE)
        || main.in_state(gui::State::MAPPING)
        || main.in_state(gui::State::IN_COMBAT))
    {
      main.keyboard_mouse();
    } else{
      main.event(gui::Event::TICK);
    }

    main.handle_world_events();
  }

  return 0;
}
